// Copyright (c) 2021 Tencent. All rights reserved.

#ifndef LEB_NETWORK_CONVERTER_AAC_ADTS_CONVERTER_H_
#define LEB_NETWORK_CONVERTER_AAC_ADTS_CONVERTER_H_

#include "leb_network/converter/base_converter.h"
#include "leb_network/base/unwrapper.h"
#include "leb_network/leb_defines.h"

namespace liteav {
namespace lebnetwork {

// Converter ADTS to ADIF format frame
class AacAdtsConverter : public BaseConverter<EncodedAudioFrame> {
 public:
  explicit AacAdtsConverter(const SdpAudioFormat& format);
  ~AacAdtsConverter();

  void Append(const RtpPacket& packet) override;

  std::vector<std::unique_ptr<EncodedAudioFrame>> Convert() override;

 private:
  SdpAudioFormat format_;
  bool sync_word_generated_;
  std::vector<std::unique_ptr<EncodedAudioFrame>> frames_;
  liteav::Unwrapper unwrapper_dts_;
};

}  // namespace lebnetwork
}  // namespace liteav

#endif  // LEB_NETWORK_CONVERTER_AAC_ADTS_CONVERTER_H_
