// Copyright (c) 2021 Tencent. All rights reserved.

#ifndef LEB_NETWORK_CONVERTER_BASE_CONVERTER_H_
#define LEB_NETWORK_CONVERTER_BASE_CONVERTER_H_

#include <memory>
#include <vector>

#include "leb_network/internal_defines.h"

namespace liteav {
namespace lebnetwork {

template <typename OUTPUT>
class BaseConverter {
 public:
  virtual ~BaseConverter() = default;
  virtual void Append(const RtpPacket& packet) = 0;
  virtual std::vector<std::unique_ptr<OUTPUT>> Convert() = 0;
};

}  // namespace lebnetwork
}  // namespace liteav

#endif  // LEB_NETWORK_CONVERTER_BASE_CONVERTER_H_
