
#include <stdio.h>
#include <stdint.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#if !defined(WEBRTC_WIN)
#include <unistd.h>
#endif

#include "leb_connection_test.h"
#if defined(WEBRTC_WIN)
#include "rtc_base/win32_socket_init.h"
#endif

//拉流地址
const char* streamUrl = "webrtc://5664.liveplay.myqcloud.com/live/5664_harchar1";

int main(int argc, char* argv[]) {

  printf("hello lebconnection demo!!, %d\n", argc);
  // signal(SIGSEGV, handler);

  if (argc != 2) {
    printf("usage: ./demo_bin streamurl, use default url\n");
  } else {
    streamUrl = argv[1];
    printf("input streamUrl %s\n", streamUrl);
  }

#if defined(WEBRTC_WIN)
    rtc::WinsockInitializer winsock_init;
#endif

  int duration_ms = 5*1000;
  // while(1)
  {
    /**
     * 1. 创建lebconnection
     */
    std::unique_ptr<liteav::lebnetwork::LEBConnectionTest> leb_connection_test;
    leb_connection_test.reset(new liteav::lebnetwork::LEBConnectionTest("./"));

    /**
     * 2. 配置拉流选项, 默认使用udp信令
     */
    liteav::lebnetwork::LEBConnection::Configuration config;
    config.stream_url = streamUrl;
    config.remote_address = "webrtc.liveplay.myqcloud.com";
    config.enable_udp_signal = true;
    config.receive_audio = true;
    config.receive_video = true;
    config.enable_encryption = false;
    config.enable_aac = true;
    config.enable_flex_fec = true;
    config.enable_audio_plc = true;
    config.enable_0rtt = true;
    config.stats_period_ms = 1000;
    config.min_delay_ms = 1000;

    /**
     * 3. 开始拉流
     */
    leb_connection_test->Start(config);

#if !defined(WEBRTC_WIN)
    // srand(time(NULL));
    // duration_ms = rand()%300;
    usleep(duration_ms*1000);
    printf("duration %d\n", duration_ms);
#endif

    /**
     * 4. 关闭lebconnection
     */
    leb_connection_test->Stop();
    leb_connection_test.reset();
  }

  printf("bye lebconnection demo!!\n");
  return 0;
}