// Copyright (c) 2021 Tencent. All rights reserved.

#ifndef RTC_STATS_REPORT_H
#define RTC_STATS_REPORT_H

#include <stdint.h>

namespace media_transport {

struct RTCStatsReport {
  // first packet info
  int32_t first_video_packet_receive_delay_ms = 0;
  int32_t first_audio_packet_receive_delay_ms = 0;
  // first frame info
  int32_t first_video_frame_output_delay_ms = 0;
  int32_t first_audio_frame_output_delay_ms = 0;

  //network
  int rttInMs = 0;

  // video
  uint32_t videoPacketsReceived = 0;
  uint64_t videoBytesReceived = 0;
  int32_t  videoPacketsLost = 0;
  uint32_t videoNackCount = 0;

  // audio
  uint32_t audioPacketsReceived = 0;
  uint64_t audioBytesReceived = 0;
  int32_t  audioPacketsLost = 0;
  uint32_t audioNackCount = 0;

};

}
#endif /* RTC_STATS_REPORT_H */
