// Copyright (c) 2021 Tencent. All rights reserved.

#ifndef RTP_PACKET_SINK_INTERFACE_H
#define RTP_PACKET_SINK_INTERFACE_H

#include <stdio.h>
#include "rtp_packet.h"
#include "acm_packet.h"
#include "vcm_packet.h"

namespace media_transport {

typedef enum RTCRtpMediaType {
  RTCRtpMediaTypeAudio,
  RTCRtpMediaTypeVideo,
/*
#ifdef WEBRTC_BUILD_DATA_CHANNEL
  RTCRtpMediaTypeData,
#endif
 */
} RTCRtpMediaType;

/**
 * RTP回调接口
 */
class RtpPacketSinkInterface {
 public:
  virtual ~RtpPacketSinkInterface() = default;

  /** RTP收包回调 */
  virtual void OnRtpPacket(const RtpPacket& packet, RTCRtpMediaType mediaType) = 0;
  
  /* metadata 数据*/
  virtual void OnRtpMetaDataPacket(const RtpMetaData& packet, RTCRtpMediaType mediaType) = 0;
  
  
  /** testing only */
  virtual void OnMediaPacket(const void* data, int length,
                             int64_t pts, RTCRtpMediaType mediaType, bool iscodec) = 0;
};

}

#endif /* RTP_PACKET_SINK_INTERFACE_H */
